package cokr.xit.fims.sndb.service;

import java.util.List;

import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.foundation.Downloadable;
import cokr.xit.foundation.data.DataObject;

/**발송 상세 관리 서비스 인터페이스.
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-12-27	JoJH 최초 작성
 * ================================
 * </pre>
 */
public interface SndngDtlService {
	List<SndngDtl> getSndngDetails(SndbQuery req);

	/**지정한 조건에 따라 발송상세 목록을 조회하여 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 목록
	 */
	List<DataObject> getSndngDtlList(SndbQuery req);

	/**지정한 조건에 따라 발송상세 객체들을 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 객체 목록
	 */
	List<DataObject> getSndngDtls(SndbQuery req);

	/**발송 ID에 따라 발송 상세 ID를 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 객체 목록
	 */
	List<DataObject> getSndngTrgtDtlIds(SndbQuery req);

	/**과태료 대장 단속 정보 등록 정보를 등록한다.
	 * @param req 발송 상세 조회 조건
	 * @return 저장 여부
	 */
	String setNxrpIndivA01List(SndngDtl sndngDtl);

	Downloadable downloadPreNotices(SndbQuery req);

	String registerPreNotice(SndbQuery req);

	/**지정한 조건에 따라 과태료 대장 등록 자료 상세 조회 목록을 조회하여 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 저장 여부
	 */
	String getNxrpIndivA03List(SndngDtl sndngDtl);

	/**지정한 조건에 따라 과태료 대장 등록 자료 상세 조회 목록을 (서울 세외수입)조회하여 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 저장 여부
	 */
	String updatePreNotice(SndngDtl sndngDtl);
	
	String updatePreNotice(String buAk);
	
	void updatePreNotices();

	/**지정한 조건에 따라 반송 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> getSndbkList(SndbQuery req);

	/**지정한 발송상세 ID의 미배달 정보를 반환한다.<br />
	 * @param sndngDtlId 발송 상세 ID
	 * @return 발송상세 미배달 정보
	 */
	DataObject getSndbkInfo(SndbQuery req);

	/**발송상세 목록의 반송 정보를 등록한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createSndbkList(SndbQuery req);

	/**발송상세 정보의 반송 정보를 등록한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createSndbk(SndngDtl sndngDtl);

	/**발송상세 정보의 반송 정보를 수정한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String updateSndbk(SndngDtl sndngDtl);

	/**발송상세 정보의 반송 정보를 삭제한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String removeSndbk(SndngDtl sndngDtl);

	List<DataObject> getDetailList(List<String> sndngIDs);
}